Wrapped asserts in critical code with CONFIG_DEBUG
[aom.git] / configure
blob7596d1124da3f24ed6cee17f3eb2d3e1bbf14e2b
1 #!/bin/bash
2 ##
3 ## configure
4 ##
5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
16 source_path=${0%/*}
17 . "${source_path}/build/make/configure.sh"
19 show_help(){
20 show_help_pre
21 cat << EOF
22 Advanced options:
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
41 ${toggle_runtime_cpu_detect} runtime cpu detection
42 ${toggle_shared} shared library support
43 ${toggle_small} favor smaller size over speed
44 ${toggle_postproc_visualizer} macro block / block level visualizers
46 Codecs:
47 Codecs can be selectively enabled or disabled individually, or by family:
48 --disable-<codec>
49 is equivalent to:
50 --disable-<codec>-encoder
51 --disable-<codec>-decoder
53 Codecs available in this distribution:
54 EOF
55 #restore editor state '
57 local family;
58 local last_family;
59 local c;
60 local str;
61 for c in ${CODECS}; do
62 family=${c%_*}
63 if [ "${family}" != "${last_family}" ]; then
64 [ -z "${str}" ] || echo "${str}"
65 str="$(printf ' %10s:' ${family})"
67 str="${str} $(printf '%10s' ${c#*_})"
68 last_family=${family}
69 done
70 echo "${str}"
71 show_help_post
75 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
78 # all_platforms is a list of all supported target platforms. Maintain
79 # alphabetically by architecture, generic-gnu last.
80 all_platforms="${all_platforms} armv5te-linux-rvct"
81 all_platforms="${all_platforms} armv5te-linux-gcc"
82 all_platforms="${all_platforms} armv5te-none-rvct"
83 all_platforms="${all_platforms} armv5te-symbian-gcc"
84 all_platforms="${all_platforms} armv6-darwin-gcc"
85 all_platforms="${all_platforms} armv6-linux-rvct"
86 all_platforms="${all_platforms} armv6-linux-gcc"
87 all_platforms="${all_platforms} armv6-none-rvct"
88 all_platforms="${all_platforms} armv6-symbian-gcc"
89 all_platforms="${all_platforms} iwmmxt-linux-rvct"
90 all_platforms="${all_platforms} iwmmxt-linux-gcc"
91 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
92 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
93 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
94 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
95 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
96 all_platforms="${all_platforms} armv7-none-rvct" #neon Cortex-A8
97 all_platforms="${all_platforms} mips32-linux-gcc"
98 all_platforms="${all_platforms} ppc32-darwin8-gcc"
99 all_platforms="${all_platforms} ppc32-darwin9-gcc"
100 all_platforms="${all_platforms} ppc32-linux-gcc"
101 all_platforms="${all_platforms} ppc64-darwin8-gcc"
102 all_platforms="${all_platforms} ppc64-darwin9-gcc"
103 all_platforms="${all_platforms} ppc64-linux-gcc"
104 all_platforms="${all_platforms} sparc-solaris-gcc"
105 all_platforms="${all_platforms} x86-darwin8-gcc"
106 all_platforms="${all_platforms} x86-darwin8-icc"
107 all_platforms="${all_platforms} x86-darwin9-gcc"
108 all_platforms="${all_platforms} x86-darwin9-icc"
109 all_platforms="${all_platforms} x86-linux-gcc"
110 all_platforms="${all_platforms} x86-linux-icc"
111 all_platforms="${all_platforms} x86-solaris-gcc"
112 all_platforms="${all_platforms} x86-win32-gcc"
113 all_platforms="${all_platforms} x86-win32-vs7"
114 all_platforms="${all_platforms} x86-win32-vs8"
115 all_platforms="${all_platforms} x86-win32-vs9"
116 all_platforms="${all_platforms} x86_64-darwin9-gcc"
117 all_platforms="${all_platforms} x86_64-darwin10-gcc"
118 all_platforms="${all_platforms} x86_64-linux-gcc"
119 all_platforms="${all_platforms} x86_64-linux-icc"
120 all_platforms="${all_platforms} x86_64-solaris-gcc"
121 all_platforms="${all_platforms} x86_64-win64-vs8"
122 all_platforms="${all_platforms} x86_64-win64-vs9"
123 all_platforms="${all_platforms} universal-darwin8-gcc"
124 all_platforms="${all_platforms} universal-darwin9-gcc"
125 all_platforms="${all_platforms} generic-gnu"
127 # all_targets is a list of all targets that can be configured
128 # note that these should be in dependency order for now.
129 all_targets="libs examples docs"
131 # all targets available are enabled, by default.
132 for t in ${all_targets}; do
133 [ -f ${source_path}/${t}.mk ] && enable ${t}
134 done
136 # check installed doxygen version
137 doxy_version=$(doxygen --version 2>/dev/null)
138 doxy_major=${doxy_version%%.*}
139 if [ ${doxy_major:-0} -ge 1 ]; then
140 doxy_version=${doxy_version#*.}
141 doxy_minor=${doxy_version%%.*}
142 doxy_patch=${doxy_version##*.}
144 [ $doxy_major -gt 1 ] && enable doxygen
145 [ $doxy_minor -gt 5 ] && enable doxygen
146 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
149 # install everything except the sources, by default. sources will have
150 # to be enabled when doing dist builds, since that's no longer a common
151 # case.
152 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
153 enable install_bins
154 enable install_libs
156 enable optimizations
157 enable fast_unaligned #allow unaligned accesses, if supported by hw
158 enable md5
159 enable spatial_resampling
160 enable multithread
161 enable os_support
163 [ -d ${source_path}/../include ] && enable alt_tree_layout
164 for d in vp8; do
165 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
166 done
168 if ! enabled alt_tree_layout; then
169 # development environment
170 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
171 else
172 # customer environment
173 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
174 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
176 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
179 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
180 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
182 ARCH_LIST="
184 mips
186 x86_64
187 ppc32
188 ppc64
190 ARCH_EXT_LIST="
191 armv5te
192 armv6
193 armv7
194 iwmmxt
195 iwmmxt2
197 mips32
201 sse2
202 sse3
203 ssse3
204 sse4_1
206 altivec
208 HAVE_LIST="
209 ${ARCH_EXT_LIST}
210 vpx_ports
211 stdint_h
212 alt_tree_layout
213 pthread_h
214 sys_mman_h
215 unistd_h
217 CONFIG_LIST="
218 external_build
219 install_docs
220 install_bins
221 install_libs
222 install_srcs
223 debug
224 gprof
225 gcov
226 rvct
228 msvs
230 big_endian
232 codec_srcs
233 debug_libs
234 fast_unaligned
235 mem_manager
236 mem_tracker
237 mem_checks
240 dequant_tokens
241 dc_recon
242 runtime_cpu_detect
243 postproc
244 multithread
245 internal_stats
246 ${CODECS}
247 ${CODEC_FAMILIES}
248 encoders
249 decoders
250 static_msvcrt
251 spatial_resampling
252 realtime_only
253 error_concealment
254 shared
255 small
256 postproc_visualizer
257 os_support
259 CMDLINE_SELECT="
260 extra_warnings
261 werror
262 install_docs
263 install_bins
264 install_libs
265 install_srcs
266 debug
267 gprof
268 gcov
270 optimizations
271 ccache
272 runtime_cpu_detect
274 libs
275 examples
276 libc
278 fast_unaligned
279 codec_srcs
280 debug_libs
283 dequant_tokens
284 dc_recon
285 postproc
286 multithread
287 internal_stats
288 ${CODECS}
289 ${CODEC_FAMILIES}
290 static_msvcrt
291 mem_tracker
292 spatial_resampling
293 realtime_only
294 error_concealment
295 shared
296 small
297 postproc_visualizer
300 process_cmdline() {
301 for opt do
302 optval="${opt#*=}"
303 case "$opt" in
304 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
305 *) process_common_cmdline "$opt"
307 esac
308 done
311 post_process_cmdline() {
312 local c
314 # If the codec family is disabled, disable all components of that family.
315 # If the codec family is enabled, enable all components of that family.
316 log_echo "Configuring selected codecs"
317 for c in ${CODECS}; do
318 disabled ${c%%_*} && disable ${c}
319 enabled ${c%%_*} && enable ${c}
320 done
322 # Enable all detected codecs, if they haven't been disabled
323 for c in ${CODECS}; do soft_enable $c; done
325 # Enable the codec family if any component of that family is enabled
326 for c in ${CODECS}; do
327 enabled $c && enable ${c%_*}
328 done
330 # Set the {en,de}coders variable if any algorithm in that class is enabled
331 for c in ${CODECS}; do
332 enabled ${c} && enable ${c##*_}s
333 done
337 process_targets() {
338 enabled child || write_common_config_banner
339 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
341 # TODO: add host tools target (obj_int_extract, etc)
343 # For fat binaries, call configure recursively to configure for each
344 # binary architecture to be included.
345 if enabled universal; then
346 # Call configure (ourselves) for each subarchitecture
347 for arch in $fat_bin_archs; do
348 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
349 done
352 # The write_common_config (config.mk) logic is deferred until after the
353 # recursive calls to configure complete, becuase we want our universal
354 # targets to be executed last.
355 write_common_config_targets
356 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
358 # Calculate the default distribution name, based on the enabled features
359 local cf
360 local DIST_DIR=vpx
361 for cf in $CODEC_FAMILIES; do
362 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
363 DIST_DIR="${DIST_DIR}-${cf}"
364 elif enabled ${cf}_encoder; then
365 DIST_DIR="${DIST_DIR}-${cf}cx"
366 elif enabled ${cf}_decoder; then
367 DIST_DIR="${DIST_DIR}-${cf}dx"
369 done
370 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
371 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
372 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
373 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
374 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
375 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
376 case "${tgt_os}" in
377 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
378 DIST_DIR="${DIST_DIR}-${tgt_cc}"
380 esac
381 if [ -f "${source_path}/build/make/version.sh" ]; then
382 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
383 DIST_DIR="${DIST_DIR}-${ver}"
384 VERSION_STRING=${ver}
385 ver=${ver%%-*}
386 VERSION_PATCH=${ver##*.}
387 ver=${ver%.*}
388 VERSION_MINOR=${ver##*.}
389 ver=${ver#v}
390 VERSION_MAJOR=${ver%.*}
392 enabled child || cat <<EOF >> config.mk
394 PREFIX=${prefix}
395 ifeq (\$(MAKECMDGOALS),dist)
396 DIST_DIR?=${DIST_DIR}
397 else
398 DIST_DIR?=\$(DESTDIR)${prefix}
399 endif
400 LIBSUBDIR=${libdir##${prefix}/}
402 VERSION_STRING=${VERSION_STRING}
404 VERSION_MAJOR=${VERSION_MAJOR}
405 VERSION_MINOR=${VERSION_MINOR}
406 VERSION_PATCH=${VERSION_PATCH}
408 CONFIGURE_ARGS=${CONFIGURE_ARGS}
410 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
413 # Write makefiles for all enabled targets
415 for tgt in libs examples docs solution; do
416 local tgt_fn="$tgt-$toolchain.mk"
418 if enabled $tgt; then
419 echo "Creating makefiles for ${toolchain} ${tgt}"
420 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
421 #write_${tgt}_config
423 done
427 process_detect() {
428 if enabled shared; then
429 # Can only build shared libs on a subset of platforms. Doing this check
430 # here rather than at option parse time because the target auto-detect
431 # magic happens after the command line has been parsed.
432 enabled linux || die "--enable-shared only supported on ELF for now"
434 if [ -z "$CC" ]; then
435 echo "Bypassing toolchain for environment detection."
436 enable external_build
437 check_header() {
438 log fake_check_header "$@"
439 header=$1
440 shift
441 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
442 disable $var
443 case $header in
444 stdio.h)
445 true;
448 local result=false
449 for d in "$@"; do
450 [ -f "${d##-I}/$header" ] && result=true && break
451 done
452 ${result:-true}
453 esac && enable $var
455 check_ld() {
456 true
459 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
460 check_ld <<EOF || die "Toolchain is unable to link executables"
461 int main(void) {return 0;}
463 # check system headers
464 check_header stdint.h
465 check_header pthread.h
466 check_header sys/mman.h
468 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
471 process_toolchain() {
472 process_common_toolchain
474 # Handle universal binaries for this architecture
475 case $toolchain in
476 universal-darwin*)
477 local darwin_ver=${tgt_os##darwin}
478 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
480 # Intel
481 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
482 if [ $darwin_ver -gt 8 ]; then
483 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
486 esac
489 # Enable some useful compiler flags
490 if enabled gcc; then
491 enabled werror && check_add_cflags -Werror
492 check_add_cflags -Wall
493 check_add_cflags -Wdeclaration-after-statement
494 check_add_cflags -Wdisabled-optimization
495 check_add_cflags -Wpointer-arith
496 check_add_cflags -Wtype-limits
497 check_add_cflags -Wcast-qual
498 enabled extra_warnings || check_add_cflags -Wno-unused-function
501 if enabled icc; then
502 enabled werror && check_add_cflags -Werror
503 check_add_cflags -Wall
504 check_add_cflags -Wpointer-arith
506 # ICC has a number of floating point optimizations that we disable
507 # in favor of deterministic output WRT to other compilers
508 add_cflags -fp-model precise
511 # Enable extra, harmless warnings. These might provide additional insight
512 # to what the compiler is doing and why, but in general, but they shouldn't
513 # be treated as fatal, even if we're treating warnings as errors.
514 GCC_EXTRA_WARNINGS="
515 -Wdisabled-optimization
516 -Winline
518 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
519 RVCT_EXTRA_WARNINGS="
520 --remarks
522 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
523 if enabled extra_warnings; then
524 for w in ${EXTRA_WARNINGS}; do
525 check_add_cflags ${w}
526 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
527 done
530 # ccache only really works on gcc toolchains
531 enabled gcc || soft_disable ccache
532 if enabled mips; then
533 enable dequant_tokens
534 enable dc_recon
537 # Enable the postbuild target if building for visual studio.
538 case "$tgt_cc" in
539 vs*) enable msvs
540 enable solution
541 vs_version=${tgt_cc##vs}
542 all_targets="${all_targets} solution"
544 esac
546 # Other toolchain specific defaults
547 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
549 if enabled postproc_visualizer; then
550 enabled postproc || die "postproc_visualizer requires postproc to be enabled"
556 ## END APPLICATION SPECIFIC CONFIGURATION
558 CONFIGURE_ARGS="$@"
559 process "$@"
560 cat <<EOF > ${BUILD_PFX}vpx_config.c
561 static const char* const cfg = "$CONFIGURE_ARGS";
562 const char *vpx_codec_build_config(void) {return cfg;}